/*
 * Copyright (c) 2015, 2016, 2017 Adrian Siekierka
 *
 * This file is part of Preston.
 *
 * Preston is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * Preston is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with Preston.  If not, see <http://www.gnu.org/licenses/>.
 */

package pl.asie.preston.container;

import net.minecraft.block.state.IBlockState;
import net.minecraft.init.Blocks;
import net.minecraft.item.ItemStack;
import net.minecraft.tileentity.TileEntity;
import net.minecraft.util.EnumFacing;
import net.minecraft.util.math.BlockPos;
import net.minecraft.world.IBlockAccess;
import net.minecraft.world.WorldType;
import net.minecraft.world.biome.Biome;
import pl.asie.preston.util.PrestonUtils;

import javax.annotation.Nullable;

public class NullBlockAccess implements IBlockAccess {
	public static final IBlockAccess INSTANCE = new NullBlockAccess();

	private NullBlockAccess() {

	}

	@Nullable
	@Override
	public TileEntity func_175625_s(BlockPos pos) {
		return null;
	}

	@Override
	public int func_175626_b(BlockPos pos, int lightValue) {
		return 0;
	}

	@Override
	public IBlockState func_180495_p(BlockPos pos) {
		return  Blocks.field_150350_a.func_176223_P();
	}

	@Override
	public boolean func_175623_d(BlockPos pos) {
		return true;
	}

	@Override
	public Biome func_180494_b(BlockPos pos) {
		return Biome.func_150568_d(1);
	}

	@Override
	public int func_175627_a(BlockPos pos, EnumFacing direction) {
		return 0;
	}

	@Override
	public WorldType func_175624_G() {
		return WorldType.field_77137_b;
	}

	@Override
	public boolean isSideSolid(BlockPos pos, EnumFacing side, boolean _default) {
		return false;
	}
}
