/*
 * Copyright (c) 2015, 2016, 2017 Adrian Siekierka
 *
 * This file is part of Preston.
 *
 * Preston is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * Preston is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with Preston.  If not, see <http://www.gnu.org/licenses/>.
 */

package pl.asie.preston.machine;

import net.minecraft.block.Block;
import net.minecraft.block.BlockHorizontal;
import net.minecraft.block.ITileEntityProvider;
import net.minecraft.block.material.MapColor;
import net.minecraft.block.material.Material;
import net.minecraft.block.properties.IProperty;
import net.minecraft.block.properties.PropertyDirection;
import net.minecraft.block.state.BlockStateContainer;
import net.minecraft.block.state.IBlockState;
import net.minecraft.entity.EntityLivingBase;
import net.minecraft.entity.player.EntityPlayer;
import net.minecraft.item.ItemStack;
import net.minecraft.tileentity.TileEntity;
import net.minecraft.util.*;
import net.minecraft.util.math.BlockPos;
import net.minecraft.world.World;
import net.minecraftforge.fml.relauncher.Side;
import net.minecraftforge.fml.relauncher.SideOnly;
import pl.asie.preston.GuiHandlerPreston;
import pl.asie.preston.PrestonMod;
import pl.asie.preston.util.BlockBase;

import javax.annotation.Nullable;

public class BlockCompressor extends BlockBase implements ITileEntityProvider {
	public static final PropertyDirection FACING = BlockHorizontal.field_185512_D;

	public BlockCompressor() {
		super(Material.field_151573_f, MapColor.field_151668_h);
		func_149647_a(PrestonMod.CREATIVE_TAB);
		func_180632_j(func_176223_P().func_177226_a(FACING, EnumFacing.NORTH));
		func_149663_c("preston.compressor");
		field_149783_u = true;
	}

	@Override
	@SideOnly(Side.CLIENT)
	public BlockRenderLayer func_180664_k() {
		return BlockRenderLayer.CUTOUT;
	}

	@Override
	protected BlockStateContainer func_180661_e() {
		return new BlockStateContainer(this, FACING);
	}

	@Override
	public boolean func_180639_a(World world, BlockPos pos, IBlockState state, EntityPlayer player, EnumHand hand, EnumFacing facing, float hitX, float hitY, float hitZ) {
		if (super.func_180639_a(world, pos, state, player, hand, facing, hitX, hitY, hitZ)) {
			return true;
		}

		TileEntity tile = world.func_175625_s(pos);
		if (tile instanceof TileCompressor) {
			player.openGui(PrestonMod.instance, GuiHandlerPreston.COMPRESSOR, world, pos.func_177958_n(), pos.func_177956_o(), pos.func_177952_p());
			return true;
		}

		return false;
	}

	@Override
	public IBlockState func_176203_a(int meta) {
		return this.func_176223_P().func_177226_a(FACING, EnumFacing.func_82600_a((meta & 3) + 2));
	}

	@Override
	public int func_176201_c(IBlockState state) {
		return (state.func_177229_b(FACING).ordinal() - 2) & 3;
	}

	@Override
	public IBlockState func_185499_a(IBlockState state, Rotation rot) {
		return state.func_177226_a(FACING, rot.func_185831_a(state.func_177229_b(FACING)));
	}

	@Override
	public IBlockState func_185471_a(IBlockState state, Mirror mirror) {
		EnumFacing facing = state.func_177229_b(FACING);
		return state.func_177226_a(FACING, mirror.func_185800_a(facing).func_185831_a(facing));
	}

	@Override
	public IBlockState func_180642_a(World world, BlockPos pos, EnumFacing facing, float hitX, float hitY, float hitZ, int meta, EntityLivingBase placer) {
		return this.func_176223_P().func_177226_a(FACING, placer.func_174811_aO().func_176734_d());
	}

	@Nullable
	@Override
	public TileEntity func_149915_a(World worldIn, int meta) {
		return new TileCompressor();
	}
}
