/*
 * Copyright (c) 2015, 2016, 2017 Adrian Siekierka
 *
 * This file is part of Preston.
 *
 * Preston is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * Preston is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with Preston.  If not, see <http://www.gnu.org/licenses/>.
 */

package pl.asie.preston.machine;

import com.google.common.collect.Lists;
import net.minecraft.inventory.Container;
import net.minecraft.item.ItemStack;
import net.minecraft.util.ResourceLocation;
import net.minecraft.util.text.translation.I18n;
import pl.asie.preston.PrestonMod;
import pl.asie.preston.util.GuiContainerBase;
import pl.asie.preston.util.PrestonUtils;

import java.math.BigInteger;

public class GuiCompressor extends GuiContainerBase {
	public static final ResourceLocation TEXTURE = new ResourceLocation("preston:textures/gui/compressor.png");
	private final ContainerCompressor owner;

	public GuiCompressor(ContainerCompressor container) {
		super(container, 176, 150);
		this.owner = container;
	}

	@Override
	protected void func_146979_b(int mouseX, int mouseY) {
		String displayName = new ItemStack(PrestonMod.blockCompressor).func_82833_r();
		this.field_146289_q.func_78276_b(displayName, this.field_146999_f / 2 - this.field_146289_q.func_78256_a(displayName) / 2, 6, 4210752);
		this.field_146289_q.func_78276_b(owner.playerInventory.func_145748_c_().func_150260_c(), 8, this.field_147000_g - 96 + 2, 4210752);
	}

	@Override
	protected void func_191948_b(int mouseX, int mouseY) {
		super.func_191948_b(mouseX, mouseY);

		if (insideRect(mouseX, mouseY, xCenter + 44 - 1, yCenter + 38 - 1, 88 + 2, 5 + 2)) {
			this.drawHoveringText(Lists.newArrayList(
				owner.owner.currentSystem.getMeter(owner.owner.getStorage())
			), mouseX, mouseY, field_146289_q);
		}
	}

	@Override
	protected void func_146976_a(float f, int i, int j) {
		super.func_146976_a(f, i, j);

		this.field_146297_k.func_110434_K().func_110577_a(TEXTURE);
		this.func_73729_b(this.xCenter, this.yCenter, 0, 0, this.field_146999_f, this.field_147000_g);
		int length = (int) Math.floor(PrestonUtils.clamp((float) owner.owner.getStorage().getFilledAmount(), 0, 1) * 88);
		this.func_73729_b(this.xCenter + 44, this.yCenter + 39, 0, this.field_147000_g, length, 5);
	}
}
