/*
 * Copyright (c) 2015, 2016, 2017 Adrian Siekierka
 *
 * This file is part of Preston.
 *
 * Preston is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * Preston is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with Preston.  If not, see <http://www.gnu.org/licenses/>.
 */

package pl.asie.preston.util;

import net.minecraft.nbt.NBTTagCompound;
import net.minecraft.network.NetworkManager;
import net.minecraft.network.play.server.SPacketUpdateTileEntity;
import net.minecraft.tileentity.TileEntity;
import net.minecraftforge.common.util.Constants;

public abstract class TileBase extends TileEntity {
	public abstract void readNBTData(NBTTagCompound compound, boolean isClient);

	public abstract NBTTagCompound writeNBTData(NBTTagCompound compound, boolean isClient);

	public boolean hasDataPacket() {
		return true;
	}

	@Override
	public final SPacketUpdateTileEntity func_189518_D_() {
		return hasDataPacket() ? new SPacketUpdateTileEntity(func_174877_v(), func_145832_p(), writeNBTData(new NBTTagCompound(), true)) : null;
	}

	@Override
	public final NBTTagCompound func_189517_E_() {
		NBTTagCompound compound = super.func_189515_b(new NBTTagCompound());
		compound = writeNBTData(compound, true);
		return compound;
	}

	@Override
	public final void onDataPacket(NetworkManager net, SPacketUpdateTileEntity pkt) {
		if (pkt != null) {
			readNBTData(pkt.func_148857_g(), true);
		}
	}

	@Override
	public final void func_145839_a(NBTTagCompound compound) {
		super.func_145839_a(compound);
		readNBTData(compound, field_145850_b != null && field_145850_b.field_72995_K);
	}

	@Override
	public final NBTTagCompound func_189515_b(NBTTagCompound compound) {
		compound = super.func_189515_b(compound);
		return writeNBTData(compound, false);
	}
}
